package net.sourceforge.nattable.filterrow.config;

import java.util.Comparator;

import net.sourceforge.nattable.data.convert.IDisplayConverter;
import net.sourceforge.nattable.filterrow.TextMatchingMode;
import net.sourceforge.nattable.style.ConfigAttribute;

/**
 * Attributes used to configure the filter row behavior.
 * @see DefaultFilterRowConfiguration 
 */
public interface FilterRowConfigAttributes {

	public static final ConfigAttribute<String> TEXT_DELIMITER = new ConfigAttribute<String>();
	public static final ConfigAttribute<TextMatchingMode> TEXT_MATCHING_MODE = new ConfigAttribute<TextMatchingMode>();
	
	/** Comparator to be used for threshold matching */
	public static final ConfigAttribute<Comparator<?>> FILTER_COMPARATOR = new ConfigAttribute<Comparator<?>>();

	/** Display converter used to convert the string typed by the user to the data type of the column */
	public static final ConfigAttribute<IDisplayConverter> FILTER_DISPLAY_CONVERTER = new ConfigAttribute<IDisplayConverter>();

}
