package net.sourceforge.nattable.hideshow.event;

import java.util.ArrayList;
import java.util.Collection;

import net.sourceforge.nattable.coordinate.PositionUtil;
import net.sourceforge.nattable.coordinate.Range;
import net.sourceforge.nattable.layer.ILayer;
import net.sourceforge.nattable.layer.event.RowStructuralChangeEvent;
import net.sourceforge.nattable.layer.event.StructuralDiff;
import net.sourceforge.nattable.layer.event.StructuralDiff.DiffTypeEnum;

public class HideRowPositionsEvent extends RowStructuralChangeEvent {

	public HideRowPositionsEvent(ILayer layer, Collection<Integer> rowPositions) {
		super(layer, PositionUtil.getRanges(rowPositions));
	}
	
	// Copy constructor
	protected HideRowPositionsEvent(HideRowPositionsEvent event) {
		super(event);
	}
	
	public HideRowPositionsEvent cloneEvent() {
		return new HideRowPositionsEvent(this);
	}
	
	public Collection<StructuralDiff> getRowDiffs() {
		Collection<StructuralDiff> rowDiffs = new ArrayList<StructuralDiff>();

		for (Range range : getRowPositionRanges()) {
			StructuralDiff diff = new StructuralDiff(DiffTypeEnum.DELETE, range, new Range(range.start, range.start));
			rowDiffs.add(diff);
		}

		return rowDiffs;
	}

	@Override
	public boolean convertToLocal(ILayer localLayer) {
		super.convertToLocal(localLayer);
		return true;
	}
}
