package net.sourceforge.nattable.tree.config;

import net.sourceforge.nattable.config.IConfigRegistry;
import net.sourceforge.nattable.layer.cell.LayerCell;
import net.sourceforge.nattable.painter.cell.TextPainter;
import net.sourceforge.nattable.tree.ITreeRowModel;


public class DefaultTreeTextPainter extends TextPainter {

	private final ITreeRowModel<?> treeRowModel;
	
	public DefaultTreeTextPainter(ITreeRowModel<?> treeRowModel) {
		this.treeRowModel = treeRowModel;
	}
	
	protected String convertDataType(LayerCell cell, IConfigRegistry configRegistry) {
		int index = cell.getLayer().getRowIndexByPosition(cell.getRowPosition());
		int depth = this.treeRowModel.depth(index);
		if (this.treeRowModel.isLeaf(index)) {
			return super.convertDataType(cell, configRegistry);
		} else {
			return this.treeRowModel.getObjectAtIndexAndDepth(index, depth);
		}
	}
	
}
